diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/fdmt-ff-mac-scheduler.h ns-3.39/src/lte/model/fdmt-ff-mac-scheduler.h
--- ns-3.38/src/lte/model/fdmt-ff-mac-scheduler.h	2023-03-16 20:54:23.768869000 -0700
+++ ns-3.39/src/lte/model/fdmt-ff-mac-scheduler.h	2023-07-05 14:23:48.009428000 -0700
@@ -21,43 +21,22 @@
 #ifndef FDMT_FF_MAC_SCHEDULER_H
 #define FDMT_FF_MAC_SCHEDULER_H
 
-#include <ns3/ff-mac-csched-sap.h>
-#include <ns3/ff-mac-sched-sap.h>
-#include <ns3/ff-mac-scheduler.h>
-#include <ns3/lte-amc.h>
-#include <ns3/lte-common.h>
-#include <ns3/lte-ffr-sap.h>
+#include "ff-mac-csched-sap.h"
+#include "ff-mac-sched-sap.h"
+#include "ff-mac-scheduler.h"
+#include "lte-amc.h"
+#include "lte-common.h"
+#include "lte-ffr-sap.h"
+
 #include <ns3/nstime.h>
 
 #include <map>
 #include <set>
 #include <vector>
 
-/**
- * value for SINR outside the range defined by FF-API, used to indicate that there
- * is no CQI for this element
- */
-#define NO_SINR -5000
-
-/// number of HARQ processes
-#define HARQ_PROC_NUM 8
-/// HARQ DL timeout
-#define HARQ_DL_TIMEOUT 11
-
 namespace ns3
 {
 
-typedef std::vector<uint8_t> DlHarqProcessesStatus_t;
-typedef std::vector<uint8_t> DlHarqProcessesTimer_t;
-typedef std::vector<DlDciListElement_s> DlHarqProcessesDciBuffer_t;
-typedef std::vector<std::vector<struct RlcPduListElement_s>>
-    RlcPduList_t; ///< vector of the LCs and layers per UE
-typedef std::vector<RlcPduList_t>
-    DlHarqRlcPduListBuffer_t; ///< vector of the 8 HARQ processes per UE
-
-typedef std::vector<UlDciListElement_s> UlHarqProcessesDciBuffer_t;
-typedef std::vector<uint8_t> UlHarqProcessesStatus_t;
-
 /**
  * \ingroup ff-api
  * \brief Implements the SCHED SAP and CSCHED SAP for a Frequency Domain Maximize Throughput
@@ -121,36 +100,31 @@
      * Csched cell config request function
      * \param params the CSched cell config request parameters
      */
-    void DoCschedCellConfigReq(
-        const struct FfMacCschedSapProvider::CschedCellConfigReqParameters& params);
+    void DoCschedCellConfigReq(const FfMacCschedSapProvider::CschedCellConfigReqParameters& params);
 
     /**
      * CSched UE config request function
      * \param params the CSChed UE config request parameters
      */
-    void DoCschedUeConfigReq(
-        const struct FfMacCschedSapProvider::CschedUeConfigReqParameters& params);
+    void DoCschedUeConfigReq(const FfMacCschedSapProvider::CschedUeConfigReqParameters& params);
 
     /**
      * CSched LC config request function
      * \param params the CSChed LC config request parameters
      */
-    void DoCschedLcConfigReq(
-        const struct FfMacCschedSapProvider::CschedLcConfigReqParameters& params);
+    void DoCschedLcConfigReq(const FfMacCschedSapProvider::CschedLcConfigReqParameters& params);
 
     /**
      * CSched LC release request function
      * \param params the CSched LC release request parameters
      */
-    void DoCschedLcReleaseReq(
-        const struct FfMacCschedSapProvider::CschedLcReleaseReqParameters& params);
+    void DoCschedLcReleaseReq(const FfMacCschedSapProvider::CschedLcReleaseReqParameters& params);
 
     /**
      * CSched UE release request function
      * \param params th CSched UE release request parameters
      */
-    void DoCschedUeReleaseReq(
-        const struct FfMacCschedSapProvider::CschedUeReleaseReqParameters& params);
+    void DoCschedUeReleaseReq(const FfMacCschedSapProvider::CschedUeReleaseReqParameters& params);
 
     //
     // Implementation of the SCHED API primitives
@@ -161,78 +135,71 @@
      * Sched DL RLC buffer request function
      * \param params the Sched DL RLC buffer request parameters
      */
-    void DoSchedDlRlcBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params);
+    void DoSchedDlRlcBufferReq(const FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params);
 
     /**
      * Sched DL paging buffer request function
-     * \param params the Sched DL paging buffer request paarameters
+     * \param params the Sched DL paging buffer request parameters
      */
     void DoSchedDlPagingBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params);
+        const FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params);
 
     /**
      * Sched DL MAC buffer request function
      * \param params the Sched DL MAC buffer request parameters
      */
-    void DoSchedDlMacBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params);
+    void DoSchedDlMacBufferReq(const FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params);
 
     /**
      * Sched DL trigger request function
      *
-     * \param params struct FfMacSchedSapProvider::SchedDlTriggerReqParameters&
+     * \param params FfMacSchedSapProvider::SchedDlTriggerReqParameters&
      */
-    void DoSchedDlTriggerReq(
-        const struct FfMacSchedSapProvider::SchedDlTriggerReqParameters& params);
+    void DoSchedDlTriggerReq(const FfMacSchedSapProvider::SchedDlTriggerReqParameters& params);
 
     /**
      * Sched DL RACH info request function
      * \param params the Sched DL RACH info request parameters
      */
-    void DoSchedDlRachInfoReq(
-        const struct FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params);
+    void DoSchedDlRachInfoReq(const FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params);
 
     /**
      * Sched DL CQI info request function
      * \param params the Sched DL CQI info request parameters
      */
-    void DoSchedDlCqiInfoReq(
-        const struct FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params);
+    void DoSchedDlCqiInfoReq(const FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params);
 
     /**
      * Sched UL trigger request function
      * \param params the Sched UL trigger request parameters
      */
-    void DoSchedUlTriggerReq(
-        const struct FfMacSchedSapProvider::SchedUlTriggerReqParameters& params);
+    void DoSchedUlTriggerReq(const FfMacSchedSapProvider::SchedUlTriggerReqParameters& params);
 
     /**
      * Sched UL noise interference request function
      * \param params the Sched UL noise interference request parameters
      */
     void DoSchedUlNoiseInterferenceReq(
-        const struct FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params);
+        const FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params);
 
     /**
      * Sched UL SR info request function
      * \param params the Sched UL SR info request parameters
      */
-    void DoSchedUlSrInfoReq(const struct FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params);
+    void DoSchedUlSrInfoReq(const FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params);
 
     /**
      * Sched UL MAC control info request function
      * \param params the Sched UL MAC control info request parameters
      */
     void DoSchedUlMacCtrlInfoReq(
-        const struct FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params);
+        const FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params);
 
     /**
      * Sched UL CQI info request function
      * \param params the Sched UL CQI info request parameters
      */
-    void DoSchedUlCqiInfoReq(
-        const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
+    void DoSchedUlCqiInfoReq(const FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
 
     /**
      * Get RBG size function
@@ -397,9 +364,9 @@
         m_ulHarqProcessesDciBuffer; ///< UL HARQ process DCI buffer
 
     // RACH attributes
-    std::vector<struct RachListElement_s> m_rachList; ///< RACH list
-    std::vector<uint16_t> m_rachAllocationMap;        ///< RACH allocation map
-    uint8_t m_ulGrantMcs;                             ///< MCS for UL grant (default 0)
+    std::vector<RachListElement_s> m_rachList; ///< RACH list
+    std::vector<uint16_t> m_rachAllocationMap; ///< RACH allocation map
+    uint8_t m_ulGrantMcs;                      ///< MCS for UL grant (default 0)
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/fdtbfq-ff-mac-scheduler.cc ns-3.39/src/lte/model/fdtbfq-ff-mac-scheduler.cc
--- ns-3.38/src/lte/model/fdtbfq-ff-mac-scheduler.cc	2023-03-16 20:54:23.768869000 -0700
+++ ns-3.39/src/lte/model/fdtbfq-ff-mac-scheduler.cc	2023-07-05 14:23:48.009428000 -0700
@@ -18,12 +18,14 @@
  * Modification: Dizhi Zhou <dizhi.zhou@gmail.com>    // modify codes related to downlink scheduler
  */
 
+#include "fdtbfq-ff-mac-scheduler.h"
+
+#include "lte-amc.h"
+#include "lte-vendor-specific-parameters.h"
+
 #include <ns3/boolean.h>
-#include <ns3/fdtbfq-ff-mac-scheduler.h>
 #include <ns3/integer.h>
 #include <ns3/log.h>
-#include <ns3/lte-amc.h>
-#include <ns3/lte-vendor-specific-parameters.h>
 #include <ns3/math.h>
 #include <ns3/pointer.h>
 #include <ns3/simulator.h>
@@ -165,7 +167,7 @@
 
 void
 FdTbfqFfMacScheduler::DoCschedCellConfigReq(
-    const struct FfMacCschedSapProvider::CschedCellConfigReqParameters& params)
+    const FfMacCschedSapProvider::CschedCellConfigReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     // Read the subset of parameters used
@@ -178,7 +180,7 @@
 
 void
 FdTbfqFfMacScheduler::DoCschedUeConfigReq(
-    const struct FfMacCschedSapProvider::CschedUeConfigReqParameters& params)
+    const FfMacCschedSapProvider::CschedUeConfigReqParameters& params)
 {
     NS_LOG_FUNCTION(this << " RNTI " << params.m_rnti << " txMode "
                          << (uint16_t)params.m_transmissionMode);
@@ -224,7 +226,7 @@
 
 void
 FdTbfqFfMacScheduler::DoCschedLcConfigReq(
-    const struct FfMacCschedSapProvider::CschedLcConfigReqParameters& params)
+    const FfMacCschedSapProvider::CschedLcConfigReqParameters& params)
 {
     NS_LOG_FUNCTION(this << " New LC, rnti: " << params.m_rnti);
 
@@ -282,7 +284,7 @@
 
 void
 FdTbfqFfMacScheduler::DoCschedLcReleaseReq(
-    const struct FfMacCschedSapProvider::CschedLcReleaseReqParameters& params)
+    const FfMacCschedSapProvider::CschedLcReleaseReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     for (std::size_t i = 0; i < params.m_logicalChannelIdentity.size(); i++)
@@ -309,7 +311,7 @@
 
 void
 FdTbfqFfMacScheduler::DoCschedUeReleaseReq(
-    const struct FfMacCschedSapProvider::CschedUeReleaseReqParameters& params)
+    const FfMacCschedSapProvider::CschedUeReleaseReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 
@@ -349,7 +351,7 @@
 
 void
 FdTbfqFfMacScheduler::DoSchedDlRlcBufferReq(
-    const struct FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params)
 {
     NS_LOG_FUNCTION(this << params.m_rnti << (uint32_t)params.m_logicalChannelIdentity);
     // API generated by RLC for updating RLC parameters on a LC (tx and retx queues)
@@ -374,7 +376,7 @@
 
 void
 FdTbfqFfMacScheduler::DoSchedDlPagingBufferReq(
-    const struct FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     NS_FATAL_ERROR("method not implemented");
@@ -382,7 +384,7 @@
 
 void
 FdTbfqFfMacScheduler::DoSchedDlMacBufferReq(
-    const struct FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     NS_FATAL_ERROR("method not implemented");
@@ -444,14 +446,8 @@
     {
         i = (i + 1) % HARQ_PROC_NUM;
     } while (((*itStat).second.at(i) != 0) && (i != (*it).second));
-    if ((*itStat).second.at(i) == 0)
-    {
-        return (true);
-    }
-    else
-    {
-        return (false); // return a not valid harq proc id
-    }
+
+    return (*itStat).second.at(i) == 0;
 }
 
 uint8_t
@@ -459,7 +455,7 @@
 {
     NS_LOG_FUNCTION(this << rnti);
 
-    if (m_harqOn == false)
+    if (!m_harqOn)
     {
         return (0);
     }
@@ -530,7 +526,7 @@
 
 void
 FdTbfqFfMacScheduler::DoSchedDlTriggerReq(
-    const struct FfMacSchedSapProvider::SchedDlTriggerReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlTriggerReqParameters& params)
 {
     NS_LOG_FUNCTION(this << " Frame no. " << (params.m_sfnSf >> 4) << " subframe no. "
                          << (0xF & params.m_sfnSf));
@@ -553,7 +549,7 @@
     rbgMap = m_ffrSapProvider->GetAvailableDlRbg();
     for (std::vector<bool>::iterator it = rbgMap.begin(); it != rbgMap.end(); it++)
     {
-        if ((*it) == true)
+        if (*it)
         {
             rbgAllocatedNum++;
         }
@@ -581,7 +577,7 @@
 
     for (std::vector<bool>::iterator it = ulRbMap.begin(); it != ulRbMap.end(); it++)
     {
-        if ((*it) == true)
+        if (*it)
         {
             if (tmpMinBandwidth > maxContinuousUlBandwidth)
             {
@@ -610,7 +606,7 @@
     m_rachAllocationMap.resize(m_cschedCellConfig.m_ulBandwidth, 0);
     uint16_t rbStart = 0;
     rbStart = ffrRbStartOffset;
-    std::vector<struct RachListElement_s>::iterator itRach;
+    std::vector<RachListElement_s>::iterator itRach;
     for (itRach = m_rachList.begin(); itRach != m_rachList.end(); itRach++)
     {
         NS_ASSERT_MSG(m_amc->GetUlTbSizeFromMcs(m_ulGrantMcs, m_cschedCellConfig.m_ulBandwidth) >
@@ -652,7 +648,7 @@
             m_rachAllocationMap.at(i) = (*itRach).m_rnti;
         }
 
-        if (m_harqOn == true)
+        if (m_harqOn)
         {
             // generate UL-DCI for HARQ retransmissions
             UlDciListElement_s uldci;
@@ -717,12 +713,12 @@
             m_dlInfoListBuffered = params.m_dlInfoList;
         }
     }
-    if (m_harqOn == false)
+    if (!m_harqOn)
     {
         // Ignore HARQ feedback
         m_dlInfoListBuffered.clear();
     }
-    std::vector<struct DlInfoListElement_s> dlInfoListUntxed;
+    std::vector<DlInfoListElement_s> dlInfoListUntxed;
     for (std::size_t i = 0; i < m_dlInfoListBuffered.size(); i++)
     {
         std::set<uint16_t>::iterator itRnti = rntiAllocated.find(m_dlInfoListBuffered.at(i).m_rnti);
@@ -813,7 +809,7 @@
             bool free = true;
             for (std::size_t j = 0; j < dciRbg.size(); j++)
             {
-                if (rbgMap.at(dciRbg.at(j)) == true)
+                if (rbgMap.at(dciRbg.at(j)))
                 {
                     free = false;
                     break;
@@ -841,7 +837,7 @@
                 std::vector<bool> rbgMapCopy = rbgMap;
                 while ((j < dciRbg.size()) && (startRbg != rbgId))
                 {
-                    if (rbgMapCopy.at(rbgId) == false)
+                    if (!rbgMapCopy.at(rbgId))
                     {
                         rbgMapCopy.at(rbgId) = true;
                         dciRbg.at(j) = rbgId;
@@ -912,7 +908,7 @@
             }
             for (std::size_t k = 0; k < (*itRlcPdu).second.at(0).at(dci.m_harqProcess).size(); k++)
             {
-                std::vector<struct RlcPduListElement_s> rlcPduListPerLc;
+                std::vector<RlcPduListElement_s> rlcPduListPerLc;
                 for (std::size_t j = 0; j < nLayers; j++)
                 {
                     if (retx.at(j))
@@ -1092,7 +1088,7 @@
             double metric =
                 (((double)(*it).second.counter) / ((double)(*it).second.tokenGenerationRate));
 
-            if (firstRnti == true)
+            if (firstRnti)
             {
                 metricMax = metric;
                 itMax = it;
@@ -1198,12 +1194,12 @@
                     continue;
                 }
 
-                if (rbgMap.at(k) == true) // this RBG is allocated in RACH procedure
+                if (rbgMap.at(k)) // this RBG is allocated in RACH procedure
                 {
                     continue;
                 }
 
-                if ((m_ffrSapProvider->IsDlRbgAvailableForUe(k, (*itMax).first)) == false)
+                if (!m_ffrSapProvider->IsDlRbgAvailableForUe(k, (*itMax).first))
                 {
                     continue;
                 }
@@ -1516,7 +1512,7 @@
                  ((*itBufReq).second.m_rlcRetransmissionQueueSize > 0) ||
                  ((*itBufReq).second.m_rlcStatusPduSize > 0)))
             {
-                std::vector<struct RlcPduListElement_s> newRlcPduLe;
+                std::vector<RlcPduListElement_s> newRlcPduLe;
                 for (uint8_t j = 0; j < nLayer; j++)
                 {
                     RlcPduListElement_s newRlcEl;
@@ -1528,7 +1524,7 @@
                     UpdateDlRlcBufferInfo(newDci.m_rnti,
                                           newRlcEl.m_logicalChannelIdentity,
                                           newRlcEl.m_size);
-                    if (m_harqOn == true)
+                    if (m_harqOn)
                     {
                         // store RLC PDU list for HARQ
                         std::map<uint16_t, DlHarqRlcPduListBuffer_t>::iterator itRlcPdu =
@@ -1558,7 +1554,7 @@
 
         newEl.m_dci = newDci;
 
-        if (m_harqOn == true)
+        if (m_harqOn)
         {
             // store DCI for HARQ
             std::map<uint16_t, DlHarqProcessesDciBuffer_t>::iterator itDci =
@@ -1592,7 +1588,7 @@
 
 void
 FdTbfqFfMacScheduler::DoSchedDlRachInfoReq(
-    const struct FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 
@@ -1601,7 +1597,7 @@
 
 void
 FdTbfqFfMacScheduler::DoSchedDlCqiInfoReq(
-    const struct FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     m_ffrSapProvider->ReportDlCqiInfo(params);
@@ -1696,7 +1692,7 @@
 
 void
 FdTbfqFfMacScheduler::DoSchedUlTriggerReq(
-    const struct FfMacSchedSapProvider::SchedUlTriggerReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlTriggerReqParameters& params)
 {
     NS_LOG_FUNCTION(this << " UL - Frame no. " << (params.m_sfnSf >> 4) << " subframe no. "
                          << (0xF & params.m_sfnSf) << " size " << params.m_ulInfoList.size());
@@ -1722,7 +1718,7 @@
 
     for (std::vector<bool>::iterator it = rbMap.begin(); it != rbMap.end(); it++)
     {
-        if ((*it) == true)
+        if (*it)
         {
             rbAllocatedNum++;
         }
@@ -1741,7 +1737,7 @@
         }
     }
 
-    if (m_harqOn == true)
+    if (m_harqOn)
     {
         //   Process UL HARQ feedback
         for (std::size_t i = 0; i < params.m_ulInfoList.size(); i++)
@@ -1781,7 +1777,7 @@
                 bool free = true;
                 for (int j = dci.m_rbStart; j < dci.m_rbStart + dci.m_rbLen; j++)
                 {
-                    if (rbMap.at(j) == true)
+                    if (rbMap.at(j))
                     {
                         free = false;
                         NS_LOG_INFO(this << " BUSY " << j);
@@ -1922,12 +1918,12 @@
             bool free = true;
             for (int j = rbAllocated; j < rbAllocated + rbPerFlow; j++)
             {
-                if (rbMap.at(j) == true)
+                if (rbMap.at(j))
                 {
                     free = false;
                     break;
                 }
-                if ((m_ffrSapProvider->IsUlRbgAvailableForUe(j, (*it).first)) == false)
+                if (!m_ffrSapProvider->IsUlRbgAvailableForUe(j, (*it).first))
                 {
                     free = false;
                     break;
@@ -2044,7 +2040,7 @@
         ret.m_dciList.push_back(uldci);
         // store DCI for HARQ_PERIOD
         uint8_t harqId = 0;
-        if (m_harqOn == true)
+        if (m_harqOn)
         {
             std::map<uint16_t, uint8_t>::iterator itProcId;
             itProcId = m_ulHarqCurrentProcessId.find(uldci.m_rnti);
@@ -2099,21 +2095,21 @@
 
 void
 FdTbfqFfMacScheduler::DoSchedUlNoiseInterferenceReq(
-    const struct FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 }
 
 void
 FdTbfqFfMacScheduler::DoSchedUlSrInfoReq(
-    const struct FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 }
 
 void
 FdTbfqFfMacScheduler::DoSchedUlMacCtrlInfoReq(
-    const struct FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 
@@ -2156,7 +2152,7 @@
 
 void
 FdTbfqFfMacScheduler::DoSchedUlCqiInfoReq(
-    const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     // retrieve the allocation for this subframe
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/fdtbfq-ff-mac-scheduler.h ns-3.39/src/lte/model/fdtbfq-ff-mac-scheduler.h
--- ns-3.38/src/lte/model/fdtbfq-ff-mac-scheduler.h	2023-03-16 20:54:23.768869000 -0700
+++ ns-3.39/src/lte/model/fdtbfq-ff-mac-scheduler.h	2023-07-05 14:23:48.009428000 -0700
@@ -21,42 +21,21 @@
 #ifndef FDTBFQ_FF_MAC_SCHEDULER_H
 #define FDTBFQ_FF_MAC_SCHEDULER_H
 
-#include <ns3/ff-mac-csched-sap.h>
-#include <ns3/ff-mac-sched-sap.h>
-#include <ns3/ff-mac-scheduler.h>
-#include <ns3/lte-amc.h>
-#include <ns3/lte-common.h>
-#include <ns3/lte-ffr-sap.h>
+#include "ff-mac-csched-sap.h"
+#include "ff-mac-sched-sap.h"
+#include "ff-mac-scheduler.h"
+#include "lte-amc.h"
+#include "lte-common.h"
+#include "lte-ffr-sap.h"
+
 #include <ns3/nstime.h>
 
 #include <map>
 #include <vector>
 
-/**
- * value for SINR outside the range defined by FF-API, used to indicate that there
- * is no CQI for this element
- */
-#define NO_SINR -5000
-
-/// HARQ number of processes
-#define HARQ_PROC_NUM 8
-/// HARQ DL timeout
-#define HARQ_DL_TIMEOUT 11
-
 namespace ns3
 {
 
-typedef std::vector<uint8_t> DlHarqProcessesStatus_t;
-typedef std::vector<uint8_t> DlHarqProcessesTimer_t;
-typedef std::vector<DlDciListElement_s> DlHarqProcessesDciBuffer_t;
-typedef std::vector<std::vector<struct RlcPduListElement_s>>
-    RlcPduList_t; ///< vector of the LCs and layers per UE
-typedef std::vector<RlcPduList_t>
-    DlHarqRlcPduListBuffer_t; ///< vector of the 8 HARQ processes per UE
-
-typedef std::vector<UlDciListElement_s> UlHarqProcessesDciBuffer_t;
-typedef std::vector<uint8_t> UlHarqProcessesStatus_t;
-
 /**
  *  Flow information
  */
@@ -162,36 +141,31 @@
      * Csched cell config request function
      * \param params the CSched cell config request parameters
      */
-    void DoCschedCellConfigReq(
-        const struct FfMacCschedSapProvider::CschedCellConfigReqParameters& params);
+    void DoCschedCellConfigReq(const FfMacCschedSapProvider::CschedCellConfigReqParameters& params);
 
     /**
      * CSched UE config request function
      * \param params CSChed UE config request parameters
      */
-    void DoCschedUeConfigReq(
-        const struct FfMacCschedSapProvider::CschedUeConfigReqParameters& params);
+    void DoCschedUeConfigReq(const FfMacCschedSapProvider::CschedUeConfigReqParameters& params);
 
     /**
      * CSched LC config request function
      * \param params the CSched LC config request parameters
      */
-    void DoCschedLcConfigReq(
-        const struct FfMacCschedSapProvider::CschedLcConfigReqParameters& params);
+    void DoCschedLcConfigReq(const FfMacCschedSapProvider::CschedLcConfigReqParameters& params);
 
     /**
      * CSched LC release request function
-     * \param params the CSChed LC releease request parameters
+     * \param params the CSChed LC release request parameters
      */
-    void DoCschedLcReleaseReq(
-        const struct FfMacCschedSapProvider::CschedLcReleaseReqParameters& params);
+    void DoCschedLcReleaseReq(const FfMacCschedSapProvider::CschedLcReleaseReqParameters& params);
 
     /**
      * CSched UE release request function
      * \param params the CSched UE release request parameters
      */
-    void DoCschedUeReleaseReq(
-        const struct FfMacCschedSapProvider::CschedUeReleaseReqParameters& params);
+    void DoCschedUeReleaseReq(const FfMacCschedSapProvider::CschedUeReleaseReqParameters& params);
 
     //
     // Implementation of the SCHED API primitives
@@ -202,78 +176,71 @@
      * Sched DL RLC buffer request function
      * \param params the Sched DL RLC buffer request parameters
      */
-    void DoSchedDlRlcBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params);
+    void DoSchedDlRlcBufferReq(const FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params);
 
     /**
      * Sched DL paging buffer request function
      * \param params the Sched DL paging buffer request parameters
      */
     void DoSchedDlPagingBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params);
+        const FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params);
 
     /**
      * Sched DL MAC  buffer request function
      * \param params Sched DL MAC buffer request parameters
      */
-    void DoSchedDlMacBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params);
+    void DoSchedDlMacBufferReq(const FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params);
 
     /**
      * Sched DL trigger request function
      *
-     * \param params struct FfMacSchedSapProvider::SchedDlTriggerReqParameters&
+     * \param params FfMacSchedSapProvider::SchedDlTriggerReqParameters&
      */
-    void DoSchedDlTriggerReq(
-        const struct FfMacSchedSapProvider::SchedDlTriggerReqParameters& params);
+    void DoSchedDlTriggerReq(const FfMacSchedSapProvider::SchedDlTriggerReqParameters& params);
 
     /**
      * Sched DL RACH info request function
      * \param params the Sched DL RACH info request parameters
      */
-    void DoSchedDlRachInfoReq(
-        const struct FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params);
+    void DoSchedDlRachInfoReq(const FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params);
 
     /**
      * Sched DL CQI info request function
      * \param params the Sched DL CQI info request parameters
      */
-    void DoSchedDlCqiInfoReq(
-        const struct FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params);
+    void DoSchedDlCqiInfoReq(const FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params);
 
     /**
      * Sched UL trigger request function
      * \param params the Sched UL trigger request parameters
      */
-    void DoSchedUlTriggerReq(
-        const struct FfMacSchedSapProvider::SchedUlTriggerReqParameters& params);
+    void DoSchedUlTriggerReq(const FfMacSchedSapProvider::SchedUlTriggerReqParameters& params);
 
     /**
      * Sched UL noise interference request function
      * \param params the Sched UL noise interference request parameters
      */
     void DoSchedUlNoiseInterferenceReq(
-        const struct FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params);
+        const FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params);
 
     /**
      * Sched UL SR info request function
      * \param params the Sched UL SR info request parameters
      */
-    void DoSchedUlSrInfoReq(const struct FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params);
+    void DoSchedUlSrInfoReq(const FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params);
 
     /**
      * Sched UL MAC control info request function
      * \param params the Sched UL MAC control info request parameters
      */
     void DoSchedUlMacCtrlInfoReq(
-        const struct FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params);
+        const FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params);
 
     /**
      * Sched UL CQI info request function
      * \param params the Sched UL CQI info request parameters
      */
-    void DoSchedUlCqiInfoReq(
-        const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
+    void DoSchedUlCqiInfoReq(const FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
 
     /**
      * Get RBG size function
@@ -449,9 +416,9 @@
         m_ulHarqProcessesDciBuffer; ///< UL HARQ process DCI buffer
 
     // RACH attributes
-    std::vector<struct RachListElement_s> m_rachList; ///< RACH list
-    std::vector<uint16_t> m_rachAllocationMap;        ///< RACH allocation map
-    uint8_t m_ulGrantMcs;                             ///< MCS for UL grant (default 0)
+    std::vector<RachListElement_s> m_rachList; ///< RACH list
+    std::vector<uint16_t> m_rachAllocationMap; ///< RACH allocation map
+    uint8_t m_ulGrantMcs;                      ///< MCS for UL grant (default 0)
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/ff-mac-common.cc ns-3.39/src/lte/model/ff-mac-common.cc
--- ns-3.38/src/lte/model/ff-mac-common.cc	2023-03-16 20:54:23.768869000 -0700
+++ ns-3.39/src/lte/model/ff-mac-common.cc	2023-07-05 14:23:48.009428000 -0700
@@ -17,7 +17,7 @@
  * Author: Marco Miozzo <mmiozzo@cttc.es>
  */
 
-#include <ns3/ff-mac-common.h>
+#include "ff-mac-common.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/ff-mac-common.h ns-3.39/src/lte/model/ff-mac-common.h
--- ns-3.38/src/lte/model/ff-mac-common.h	2023-03-16 20:54:23.768869000 -0700
+++ ns-3.39/src/lte/model/ff-mac-common.h	2023-07-05 14:23:48.009428000 -0700
@@ -215,6 +215,7 @@
     {
         QBT_NON_GBR,
         QBT_GBR,
+        QBT_DGBR,
         NotValid_QosBearerType
     } m_qosBearerType{NotValid_QosBearerType}; ///< the QOS bearer type
 
@@ -262,14 +263,14 @@
 };
 
 /**
- * \brief See section 4.3.8 builDataListElement
+ * \brief See section 4.3.8 buildDataListElement
  * \struct BuildDataListElement_s
  */
 struct BuildDataListElement_s
 {
     uint16_t m_rnti{UINT16_MAX};                                       ///< RNTI
     struct DlDciListElement_s m_dci;                                   ///< DCI
-    std::vector<enum CeBitmap_e> m_ceBitmap;                           ///< CE bitmap
+    std::vector<CeBitmap_e> m_ceBitmap;                                ///< CE bitmap
     std::vector<std::vector<struct RlcPduListElement_s>> m_rlcPduList; ///< RLC PDU list
 };
 
@@ -474,7 +475,8 @@
         NACK,
         DTX
     };
-    std::vector<enum HarqStatus_e> m_harqStatus; ///< HARQ status
+
+    std::vector<HarqStatus_e> m_harqStatus; ///< HARQ status
 };
 
 /**
